Unit U_ASCTLK;
{ 24.04.2005:
  ࠢ ஡  '@'  । ப }
Interface
Uses UFH_TLK;
Const
 DOG_PREFIX = '@';
 DOG_SOUND  = 'sound';
 DOG_LENGTH = 'leng';
 DOG_END    = 'end';

Type
 TRange   = 0..$7FFF;
 {TResRef  = array [0..15]  of char;}
 TLongArr = array [TRange] of char;
 PLongArr = ^TLongArr;

Type
 PTextBlock = ^TTextBlock;
 TTextBlock = object
   poArr: PLongArr;  { ᨢ -  ⥪ }
 { poFirst: PLongArr; }
   nSize,     { ࠧ ᨢ }
   ind: word; {    ᨢ }
   constructor Init;
   destructor Done;

   procedure PutTextBlock(poTextToPut: PLongArr);
   procedure SetCurrentPosition(nPos: word);
   function GetCurrentPosition: word;
   function GetElem(nPos: word): char;
   function GetBlockSize: word;
   function GetPosOfNextDog: word;
   function GetPosOfNextWord: word;
   function GetPosOfNextLine: word;
   function GetPosOfPrevLineEnd: word; {  ᫥ 樨 ।饩  }
   function GetBlockFromPosition(nPos: word): PChar; { 㪠⥫  poArr^[nPos] }
   { GetDog & GetWord 뤥   , 㤠  㪠뢠 }
   function GetDog: PChar; { ⠥ ᫮ ᫥ @  ⠭  ᫥  襭 }
   function GetWord: PChar;
 end;
{===================  End of Type section ========================}


(*= TruncFromLeft, proc.=============================*
 १  ப zStr  樨 nPos, ..,
 䠪᪨, ७ ࠢ  ப   砫.
 ਬ (⠥ 'World!'):
         {0123456789012}
  zStr:= 'Hello, World!';
  TruncFromLeft(zStr, 7);
  Writeln(zStr);             <=======================*)
procedure TruncFromLeft(var zStr: PChar; nPos: word);


(*= TruncFromRight, proc.=============================*
 १  ப zStr ࠢ 樨 nPos, ..,
 䠪᪨, 頥 #0   nPos+1;
 ਬ (⠥ 'Hello'):
         {0123456789012}
  zStr:= 'Hello, World!';
  TruncFromLeft(zStr, 4);
  Writeln(zStr);            <=========================*)
procedure TruncFromRight(var zStr: PChar; nPos: word);

procedure CompileTLK(var fIn, fOut: file; var Header: THeader);

{-=================================================-}

Implementation

uses strings, crt;
{-=TTextBlock methods=-}
constructor TTextBlock.Init;
begin
 ind:= 0;
 nSize:= 0;
 poArr:= nil;
{poFirst:= nil;}
end;

destructor TTextBlock.Done;
begin
  if poArr <> nil then
    dispose(poArr);
{ if (poFirst <> poArr) and (poFirst <> nil) then
     dispose(poFirst); }
end;

procedure TTextBlock.PutTextBlock(poTextToPut: PLongArr);
begin
 poArr:= poTextToPut;
 nSize:= SizeOf(poArr^);
 poArr^[nSize-1]:= #0;
{if poFirst = nil then
   poFirst:= poArr;}
 ind:= 0;
end;

procedure TTextBlock.SetCurrentPosition(nPos: word);
begin
 ind:= nPos;
end;

function TTextBlock.GetCurrentPosition: word;
begin
 GetCurrentPosition:= ind;
end;

function TTextBlock.GetBlockSize: word;
begin
  GetBlockSize:= nSize;
end;

function TTextBlock.GetElem(nPos: word): char;
begin
  GetElem:= poArr^[nPos];
end;

{ 頥  樨 ࢮ ᮡ (ᨬ '@') 稭
   ⥪饩 樨,   ᫥ - , ᫨
   ᮡ  㤠. ⠭    
  23.04.2005:
   㥬 @  । ப }
function TTextBlock.GetPosOfNextDog: word;
var nPos: word;
begin
  nPos:= GetCurrentPosition;
  while nPos < GetBlockSize-1 do
  begin
    if (GetElem(nPos) = DOG_PREFIX) and
       ((nPos = 0) or (GetElem(nPos-1) = #10)) then
       break;
    inc(nPos);
  end;
  SetCurrentPosition(nPos);
  GetPosOfNextDog:= nPos;
end;

function TTextBlock.GetPosOfNextWord: word;
var
 nPos: word;
 Elem: char;
begin
  nPos:= GetCurrentPosition;
  Elem:= GetElem(nPos);
  { ய᪠ 㪢 ⥪饣 ᫮ }
  { NOT space, return, newline, tab }
  while not (ord(Elem) in [32, 13, 10, 9]) and
        (nPos < GetBlockSize-1) do
  begin
    inc(nPos);
    Elem:= GetElem(nPos);
  end;
  { ய᪠ ஡ }
  while (ord(Elem) in [32, 13, 10, 9]) and
        (nPos < GetBlockSize-1)  do
  begin
    inc(nPos);
    Elem:= GetElem(nPos);
  end;
  SetCurrentPosition(nPos);
  GetPosOfNextWord:= nPos;
end;

function TTextBlock.GetPosOfNextLine: word;
var
 nPos: word;
 Elem: char;
begin
  nPos:= GetCurrentPosition;
  Elem:= GetElem(nPos);
  { ய᪠ c ⥪饩 ப }
  { NOT newline, tab }
  while not (ord(Elem) in [13, 10]) and (nPos < GetBlockSize-1) do
  begin
    inc(nPos);
    Elem:= GetElem(nPos);
  end;
  { யc \r\n }
  while (ord(Elem) in [13, 10]) and
        (nPos < GetBlockSize-1)  do
  begin
    inc(nPos);
    Elem:= GetElem(nPos);
  end;
  SetCurrentPosition(nPos);
  GetPosOfNextLine:= nPos;
end;

{ 頥  ᫥ 樨 ।饩  ⮩(!)  }
function TTextBlock.GetPosOfPrevLineEnd: word;
var
 nPos: word;
 Elem: char;
begin
  nPos:= GetCurrentPosition;
  Elem:= GetElem(nPos);
  { ய᪠ c ⥪饩 ப }
  { NOT newline, tab }
  while not (ord(Elem) in [13, 10]) and (nPos > 0) do
  begin
    dec(nPos);
    Elem:= GetElem(nPos);
  end;
  { யc \r\n }
  while (ord(Elem) in [13, 10]) and (nPos > 0) do
  begin
    dec(nPos);
    Elem:= GetElem(nPos);
  end;
  SetCurrentPosition(nPos);
  GetPosOfPrevLineEnd:= nPos;
end;

{ 頥 㪠⥫  poArr^[nPos].  뤥 }
function TTextBlock.GetBlockFromPosition(nPos: word): PChar;
begin
 if (poArr <> nil) and (nPos < GetBlockSize-1) then
   GetBlockFromPosition:= @poArr^[nPos]
 else GetBlockFromPosition:= nil;
end;

{ 뤥   , 頥 㤠 ᫮
  ᫥ ࢮ   ⥪饩 樨 ᨬ '@'
   頥 㪠⥫   }
function TTextBlock.GetDog: PChar; { ⠥ ᫮ ᫥ @  ⠭  ᫥  襭 }
var
 nPos: word;
 Elem: char;
begin
  nPos:= GetCurrentPosition;
  Elem:= GetElem(nPos);
  while (Elem <> DOG_PREFIX) and
        (nPos < GetBlockSize-1) do
  begin
    inc(nPos);
    Elem:= GetElem(nPos);
  end;
  if (Elem = DOG_PREFIX) and
     (nPos < GetBlockSize-1) then
  begin
    inc(nPos);
    SetCurrentPosition(nPos);
    GetDog:= GetWord;
  end
  else GetDog:= nil;
end;

function TTextBlock.GetWord: PChar;
var
 i, nPos, nCount: word;
 Elem: char;
 zResult: PChar;
begin
 zResult:= nil;
 nPos:= GetCurrentPosition;
 i:= nPos;
 if i < GetBlockSize-1 then
 begin
   Elem:= GetElem(i);
   while (ord(Elem) in [32, 13, 10, 9]) and
         (i < GetBlockSize-1) do
   begin
     inc(i);
     nPos:= i;
     Elem:= GetElem(i);
   end;
   while (not (ord(Elem) in [32, 13, 10, 9])) and
         (i < GetBlockSize-1) do
   begin
     inc(i);
     Elem:= GetElem(i);
   end;
   if (i < GetBlockSize-1) then { ᫮  뢥 殬 ᨢ }
   begin
     nCount:= i-nPos;
     GetMem(zResult, nCount+1);
     StrMove(zResult, PChar(@poArr^[nPos]), nCount);
     zResult[nCount]:= #0;
   end;
 end;
 GetWord:= zResult;
end;
{==== End of TTextBlock method section ====}

procedure TruncFromLeft(var zStr: PChar; nPos: word);
var
 zSub: PChar;
 n: word;
begin
 if nPos < StrLen(zStr) then begin
   zSub:= @zStr[nPos]; {㪠⥫  nPos ᨬ}
   n:= StrLen(zSub);
   StrCopy(zStr, zSub);
   {zStr[n]:= #0;}
 end
 else zStr[0]:= #0;
end;

procedure TruncFromRight(var zStr: PChar; nPos: word);
begin
 if nPos < StrLen(zStr) then begin
   zStr[nPos+1]:= #0;
 end;
end;

procedure CompileTLK(var fIn, fOut: file; var Header: THeader);
var
 oText: PTextBlock;{ ࠡ稩  ⥪  室 䠩 }
{nPos,}
 nDogPos,
 nEntryIDPos,      {  ( oBlock.poArr^) ࢮ ᨬ StrRef-䨪 }
 nEntryTextPos,    {  ࢮ ᨬ ⥪ StrRef- }
 nEntryTextEndPos: {  ᫥ ᨬ ⥪ StrRef- }
 word;

 i,                { 稪 ᠭ ப }
 nPrevID,          {  ᫥ ᠭ ப TLK }
 nPrevStrEnd,      {  ।饩 ப (  Header.StrEntr) }
 nEntryID: dword;
{nCurrID: dword;   {  뢠 ப TLK }

{nAbsOfs,          { ᬥ饭  砫 䠩 fOut }
{nRelOfs: longint; { ᬥ饭  Header.StrEntr }

{buf:   TLongArr;  {   ⥭  室 䠩 }
 poBuf: PLongArr;
{zWord,{}
 zStr:  PChar;
 zDog:  PChar;     { ASCIIZ ப, ᮤঠ ᫮ ᫥ "@" }


 DT:  TStrData;    { ⠡  뢠 ப TLK }
 n,
 nBytesRead: word; { ⠭ ⮢ . BlockRead }
 iChRead: integer; { ⠭ ⮢  ப . Val }

 bDone:   boolean;

begin
 Seek(fOut, 0);
 BlockWrite(fOut, Header, HeaderSize);
 seek(fIn, 5);  { ய᪠  6 ⮢ "@tlk,#10"}
 New(oText, Init);
 nPrevID:= -1;
 nPrevStrEnd:= 0;

   i:= 0;
   bDone:= FALSE;

   New(poBuf);
   BlockRead(fIn, poBuf^, High(TLongArr), nBytesRead);
   with oText^ do begin
     PutTextBlock(poBuf);  (*!*)
     while (i < Header.StrCount) do
     begin
       GotoXY(2, WhereY);
       write(i,':');

       DT:= DT_NULL;
       { 饬 । 䨪 ப  䠩 }
       repeat
         nEntryIDPos:= GetPosOfNextDog; (*!*)
         SetCurrentPosition(nEntryIDPos);
         zDog:= GetDog;(*nEntryIDPos); (*!*)
         Val(zDog, nEntryID, iChRead);
         if zDog = nil then { ⨣   }
         begin
          (*! ନ 楤ன  ⮤ !*)
          zStr:= GetBlockFromPosition(0);  { 㪠⥫  oText.poArr^ }
          TruncFromLeft(zStr, nEntryIDPos);
          N:= GetBlockSize-1; { High(TLongArr) }
          zStr:= GetBlockFromPosition(N-nEntryIDPos);
          BlockRead(fIn, zStr^,  nEntryIDPos, nBytesRead);
          zStr:= nil;
          SetCurrentPosition(0);
          if nBytesRead < nEntryIDPos then { ⨣  䠩}
          begin
            bDone:= TRUE;
          end;
         end; { if zDog = nil }
         StrDispose(zDog);
         zDog:= nil;
       until (iChRead = 0);

       { ⠭ ணࠬ, ᫨ ப    浪 }
       if (nEntryID < nPrevID) or (nEntryID >= Header.StrCount) then
       begin
         Writeln('Error! Wrong order of strings.');
         close(fOut);
         close(fIn);
         halt(1);
       end;
       { ᫨ 㦭, 뢠 ⠡   ப }
       while (nEntryID > i) do
       begin
         Seek(fOut, GetStrDataOfs(i));
         BlockWrite(fOut, DT_NULL, DTableSize);
         inc(i);
       end;
       { ।塞 ࠬ ப (砥 㪠, ⥪  ..) }
       repeat
         nEntryTextPos:= GetPosOfNextLine; (*!*)
         {SetCurrentPosition(nEntryTextPos);{in function}
         nDogPos:= GetPosOfNextDog;
         zDog:= GetDog;(*nPos); (*! ⮤ ⠥ ᫮ ᫥ @  ⠭  ᫥  襭 *)
         if StrPas(StrLower(zDog)) = DOG_SOUND then
         begin
            nDogPos:= GetPosOfNextWord; (*!*)
            zStr:= GetWord;(*nPos); (*!*)
            if zStr = nil then
             continue;
            StrMove(DT.SndFile, zStr, StrLen(zStr));
            DT.Flags:= DT.Flags or $06; { bin 110 }

            StrDispose(zStr);
            zStr:= nil;
            StrDispose(zDog);
            zDog:= nil;
            continue;
         end { DOG_SOUND }
         else if StrPas(StrLower(zDog)) = DOG_LENGTH then
         begin
            nDogPos:= GetPosOfNextWord; (*!*)
            zStr:= GetWord;(*nPos); (*!*)
            if zStr = nil then
             continue;
            Val(StrPas(zStr), DT.SndLeng, iChRead);

            StrDispose(zStr);
            zStr:= nil;
            StrDispose(zDog);
            zDog:= nil;
            continue;
         end { DOG_LENGTH }
         else if (zDog = nil) then
         begin
     (*!* )
           Close(fOut);
           WriteLn('Halt on: i=',i);
           halt;(*!*)
           if bDone then {  ⨣  䠩 fIn }
           begin
            while (i < Header.StrCount) do
            begin
              Seek(fOut, GetStrDataOfs(i));
              BlockWrite(fOut, DT_NULL, DTableSize);
              inc(i);
            end;
           end
           else begin
            zStr:= GetBlockFromPosition(0);  { 㪠⥫  oText.poArr^ }
            TruncFromLeft(zStr, nEntryIDPos); { ७ᨬ   砫 ᨢ }
            N:= GetBlockSize-1; (*! ⮤ 頥 ࠧ ᨢ .poArr^ *)
            { 碥 㪠⥫  ᢮  ᨢ }
            zStr:= GetBlockFromPosition(N-nEntryIDPos);
            { 塞 ᢮  }
            BlockRead(fIn, zStr^, nEntryIDPos, nBytesRead);
            zStr:= nil;
            SetCurrentPosition(0);
            if nBytesRead < nEntryIDPos then { ⨣  䠩}
            begin
             bDone:= TRUE;
            end;
           end;
         end { if zDog = nil }
         else
           continue;
       until StrPas(StrLower(zDog)) = DOG_END;
       if zDog <> nil then
       begin
         StrDispose(zDog);
         zDog:= nil;
       end;
       {   ਧ 襭  (@end)  ᮢ
          砫 ᫥. ,    室 ⥪  }
       if nDogPos <> nEntryTextPos then
       begin
         SetCurrentPosition(nDogPos);
         nEntryTextEndPos:= GetPosOfPrevLineEnd; (*! ⮤ ।  ᫥ 樨 ।饩  *)
         DT.StrSize:= nEntryTextEndPos - nEntryTextPos + 1;
         DT.StrOfs:= nPrevStrEnd;
         DT.Flags:= DT.Flags or $01; {110 or 001 = 111}
         zStr:= GetBlockFromPosition(nEntryTextPos); (*! ⮤ 頥 㪠⥫  -(!) poArr^[i]  PChar *)
         Seek(fOut, DT.StrOfs+Header.StrEntr);
         BlockWrite(fOut, zStr^, DT.StrSize);
         nPrevStrEnd:= FilePos(fOut)-Header.StrEntr; {  稫  ப }
         zStr:= nil;
       end;
       { 襬 ⠡  }
       Seek(fOut, GetStrDataOfs(nEntryID)); { c. ufh_tlk }
       BlockWrite(fOut, DT, DTableSize);
       nPrevID:= nEntryID;

       inc(i);
       ShowProgress(i, Header.StrCount);
     end; { while (i < StrCount) }
   end; { with oText}

 Dispose(oText, Done);
 Close(fOut);

end;

End.
